#!/usr/bin/env python
#coding: utf-8

import os
import sys
import subprocess
import shutil
import stat
import copy_to_ftp

MAX_BACKUPS = 50
BACKUP_DIR = "/backup/mysql"
CURRENT_FILE = "/backup/mysql/.current"
MYSQL_ROOTPW_FILE = "/opt/pdadmin/etc/mysql_rootpw.conf"
MYSQL = "/usr/local/pd-admin2/bin/mysql"
MYSQLDUMP = "/usr/local/pd-admin2/bin/mysqldump"
GZIP = "/bin/gzip"


def main():
    # MySQL-Root-Passwort auslesen
    password = file(MYSQL_ROOTPW_FILE, "r").readline().strip()
    
    # Current-Datei auslesen
    if os.path.isfile(CURRENT_FILE):
        try:
            current = int(file(CURRENT_FILE, "r").readline().strip()) + 1
        except ValueError:
            current = 1
    else:
        current = 1
    if current > MAX_BACKUPS:
        current = 1
    
    # Pfad für Sicherung
    dest_dir = os.path.join(BACKUP_DIR, str(current))
    if os.path.isdir(dest_dir):
        shutil.rmtree(dest_dir, ignore_errors = True)
    os.makedirs(dest_dir)
    os.chmod(BACKUP_DIR, stat.S_IRUSR | stat.S_IWUSR | stat.S_IXUSR)
    os.chmod(dest_dir, stat.S_IRUSR | stat.S_IWUSR | stat.S_IXUSR)

    args = [MYSQL, "--user=root", "--password=%s" % password]
    proc = subprocess.Popen(args, stdin = subprocess.PIPE, stdout = subprocess.PIPE)
    proc.stdin.write("SHOW DATABASES;")
    proc.stdin.close()
    proc.stdout.readline()
    for line in proc.stdout:
        dbname = line.strip()
        print "Backup:", dbname
        
        # Dateiname zusammensetzen
        sql_file_name = os.path.join(dest_dir, dbname + ".sql")
        
        # Sichern
        cmd = (
            MYSQLDUMP
            ' --user="root" --password="%s" %s > %s'
        ) % (password, dbname, sql_file_name)
        os.system(cmd)
        
        # Zippen
        cmd = "%s %s" % (GZIP, sql_file_name)
        os.system(cmd)

    # Current-Datei neu schreiben
    f = file(CURRENT_FILE, "w")
    f.write(str(current))
    f.close()
    
    # Neue Dateien zum FTP-Server kopieren
    if "--copy_to_ftp" in sys.argv:
        copy_to_ftp.copy_to_ftp__mysql()


if __name__ == "__main__":
    main()

